unit prioparmonline_main;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Spin, LConvEncoding, SpinEx;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button_Abfrage1: TButton;
    Button_Auswertung: TButton;
    Button_Ergebnis: TButton;
    Label_Analyse: TLabel;
    Label_Parameter: TLabel;
    Label_Standard_Puffer: TLabel;
    Label_Analyse_frei: TLabel;
    Label_Standard_Zeilen: TLabel;
    Label_Analyse_Verfahren: TLabel;
    Label_Analyse_Puffer: TLabel;
    Label_Analyse_Zeilen: TLabel;
    Label_Parameter_Verfahren: TLabel;
    Label_Parameter_Puffer: TLabel;
    Label_Parameter_Zeilen: TLabel;
    Label_Analyse_Vorhanden: TLabel;
    Label_Parameter_Vorhanden: TLabel;
    Label_Standard_Wert: TLabel;
    Label_Standard_Vorhanden: TLabel;
    Label_Standard_Verfahren: TLabel;
    Label_Standard: TLabel;
    Label_Analyse_Wert: TLabel;
    Label_Parameter_Wert: TLabel;
    Memo_Auswerten: TMemo;
    SpinEdit_Standard_Verfahren: TSpinEdit;
    SpinEdit_Standard_Puffer: TSpinEdit;
    SpinEdit_Standard_Zeilen: TSpinEdit;
    SpinEdit_Analyse_Verfahren: TSpinEdit;
    SpinEdit_Analyse_Puffer: TSpinEdit;
    SpinEdit_Analyse_Zeilen: TSpinEdit;
    SpinEdit_Parameter_Verfahren: TSpinEdit;
    SpinEdit_Parameter_Puffer: TSpinEdit;
    SpinEdit_Parameter_Zeilen: TSpinEdit;
    ToggleBox_Standard_Verfahren: TToggleBox;
    ToggleBox_Standard_Puffer: TToggleBox;
    ToggleBox_Analyse_Frei: TToggleBox;
    ToggleBox_Standard_Zeilen: TToggleBox;
    ToggleBox_Analyse_Verfahren: TToggleBox;
    ToggleBox_Analyse_Puffer: TToggleBox;
    ToggleBox_Analyse_Zeilen: TToggleBox;
    ToggleBox_Parameter_Verfahren: TToggleBox;
    ToggleBox_Parameter_Puffer: TToggleBox;
    ToggleBox_Parameter_Zeilen: TToggleBox;

    procedure Zeige;
    procedure Zeige_Parm;
    procedure Zeige_Analyse;
    procedure Ergebnis;
    procedure Auswerten_Parm(ausgabe: boolean);
    procedure Auswerten_Analyse(ausgabe: boolean);
    procedure Setze_B0_P0(ausgabe: boolean);
    procedure Scannen_Werte;

    procedure Button_AuswertungClick(Sender: TObject);
    procedure Button_AbfrageClick(Sender: TObject);
    procedure Button_ErgebnisClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ToggleBox_AnalysefreiChange(Sender: TObject);
    procedure ToggleBox_Standard_ZeilenChange(Sender: TObject);
    procedure ToggleBox_Standard_PufferChange(Sender: TObject);
    procedure ToggleBox_Analyse_VerfahrenChange(Sender: TObject);
    procedure ToggleBox_Analyse_ZeilenChange(Sender: TObject);
    procedure ToggleBox_Analyse_PufferChange(Sender: TObject);
    procedure ToggleBox_Parameter_VerfahrenChange(Sender: TObject);
    procedure ToggleBox_Parameter_ZeilenChange(Sender: TObject);
    procedure ToggleBox_Parameter_PufferChange(Sender: TObject);
    function JaNein(wert:boolean):String;
  private
    { Private-Deklarationen }
    var std_buffer, std_zeilen, std_verf: integer;
        parm_buffer, parm_zeilen, parm_verf: integer;
        vparm_buffer, vparm_zeilen, vparm_verf: boolean;
        anly_buffer, anly_zeilen, anly_verf: integer;
        vanly_buffer, vanly_zeilen, vanly_verf: boolean;
        analysefrei, baumalgo: boolean;
        buffermax, blattmax, dynlaenge: integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

function TForm1.JaNein(wert:boolean):String;
begin
   if wert then JaNein:='Ja' else JaNein:='Nein';
end;

procedure TForm1.Scannen_Werte;
begin
   vparm_verf:=ToggleBox_Parameter_Verfahren.Checked;
   vparm_buffer:=ToggleBox_Parameter_Puffer.Checked;
   vparm_zeilen:=ToggleBox_Parameter_Zeilen.Checked;
   vanly_verf:=ToggleBox_Analyse_Verfahren.Checked;
   vanly_buffer:=ToggleBox_Analyse_Puffer.Checked;
   vanly_zeilen:=ToggleBox_Analyse_Zeilen.Checked;
   std_verf:=SpinEdit_Standard_Verfahren.Value;
   std_buffer:=SpinEdit_Standard_Puffer.Value;
   std_zeilen:=SpinEdit_Standard_Zeilen.Value;
   anly_verf:=SpinEdit_Analyse_Verfahren.Value;
   anly_buffer:=SpinEdit_Analyse_Puffer.Value;
   anly_zeilen:=SpinEdit_Analyse_Zeilen.Value;
   parm_verf:=SpinEdit_Parameter_Verfahren.Value;
   parm_buffer:=SpinEdit_Parameter_Puffer.Value;
   parm_zeilen:=SpinEdit_Parameter_Zeilen.Value;
   analysefrei:=ToggleBox_Analyse_Frei.Checked;
end;

procedure TForm1.ToggleBox_AnalysefreiChange(Sender: TObject);
begin
   ToggleBox_Analyse_Frei.Caption:=JaNein(ToggleBox_Analyse_Frei.Checked);
end;

procedure TForm1.ToggleBox_Standard_ZeilenChange(Sender: TObject);
begin
   ToggleBox_Standard_Zeilen.Caption:=JaNein(ToggleBox_Standard_Zeilen.Checked);
   SpinEdit_Standard_Zeilen.Enabled:=ToggleBox_Standard_Zeilen.Checked;
end;

procedure TForm1.ToggleBox_Standard_PufferChange(Sender: TObject);
begin
   ToggleBox_Standard_Puffer.Caption:=JaNein(ToggleBox_Standard_Puffer.Checked);
   SpinEdit_Standard_Puffer.Enabled:=ToggleBox_Standard_Puffer.Checked;
end;

procedure TForm1.ToggleBox_Analyse_VerfahrenChange(Sender: TObject);
begin
   ToggleBox_Analyse_Verfahren.Caption:=JaNein(ToggleBox_Analyse_Verfahren.Checked);
   SpinEdit_Analyse_Verfahren.Enabled:=ToggleBox_Analyse_Verfahren.Checked;
end;

procedure TForm1.ToggleBox_Analyse_ZeilenChange(Sender: TObject);
begin
   ToggleBox_Analyse_Zeilen.Caption:=JaNein(ToggleBox_Analyse_Zeilen.Checked);
   SpinEdit_Analyse_Zeilen.Enabled:=ToggleBox_Analyse_Zeilen.Checked;
end;

procedure TForm1.ToggleBox_Analyse_PufferChange(Sender: TObject);
begin
   ToggleBox_Analyse_Puffer.Caption:=JaNein(ToggleBox_Analyse_Puffer.Checked);
   SpinEdit_Analyse_Puffer.Enabled:=ToggleBox_Analyse_Puffer.Checked;
end;

procedure TForm1.ToggleBox_Parameter_VerfahrenChange(Sender: TObject);
begin
   ToggleBox_Parameter_Verfahren.Caption:=JaNein(ToggleBox_Parameter_Verfahren.Checked);
   SpinEdit_Parameter_Verfahren.Enabled:=ToggleBox_Parameter_Verfahren.Checked;
end;

procedure TForm1.ToggleBox_Parameter_ZeilenChange(Sender: TObject);
begin
   ToggleBox_Parameter_Zeilen.Caption:=JaNein(ToggleBox_Parameter_Zeilen.Checked);
   SpinEdit_Parameter_Zeilen.Enabled:=ToggleBox_Parameter_Zeilen.Checked;
end;

procedure TForm1.ToggleBox_Parameter_PufferChange(Sender: TObject);
begin
   ToggleBox_Parameter_Puffer.Caption:=JaNein(ToggleBox_Parameter_Puffer.Checked);
   SpinEdit_Parameter_Puffer.Enabled:=ToggleBox_Parameter_Puffer.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   SpinEdit_Standard_Verfahren.MinValue:=0;
   SpinEdit_Standard_Verfahren.MaxValue:=5;
   SpinEdit_Standard_Verfahren.Value:=1;
   SpinEdit_Standard_Verfahren.Enabled:=true;
   SpinEdit_Standard_Zeilen.MinValue:=1;
   SpinEdit_Standard_Zeilen.MaxValue:=1000000;
   SpinEdit_Standard_Zeilen.Value:=3;
   SpinEdit_Standard_Zeilen.Enabled:=true;
   SpinEdit_Standard_Puffer.MinValue:=0;
   SpinEdit_Standard_Puffer.MaxValue:=999;
   SpinEdit_Standard_Puffer.Value:=2;
   SpinEdit_Standard_Puffer.Enabled:=true;
   SpinEdit_Analyse_Verfahren.MinValue:=0;
   SpinEdit_Analyse_Verfahren.MaxValue:=5;
   SpinEdit_Analyse_Zeilen.MinValue:=1;
   SpinEdit_Analyse_Zeilen.MaxValue:=1000000;
   SpinEdit_Analyse_Puffer.MinValue:=0;
   SpinEdit_Analyse_Puffer.MaxValue:=999;
   SpinEdit_Parameter_Verfahren.MinValue:=0;
   SpinEdit_Parameter_Verfahren.MaxValue:=5;
   SpinEdit_Parameter_Zeilen.MinValue:=1;
   SpinEdit_Parameter_Zeilen.MaxValue:=1000000;
   SpinEdit_Parameter_Puffer.MinValue:=0;
   SpinEdit_Parameter_Puffer.MaxValue:=999;
   analysefrei:=false; baumalgo:=false;
   buffermax:=0; blattmax:=0; dynlaenge:=5000;
   Scannen_Werte;
end;

procedure TForm1.Button_AbfrageClick(Sender: TObject);
var t:string;
begin
   Scannen_Werte;
   Memo_Auswerten.Clear;
   t:='Standard Verfahren ist ' + ToggleBox_Standard_Verfahren.Caption;
   if ToggleBox_Standard_Verfahren.Checked then t:=t+' : ' + SpinEdit_Standard_Verfahren.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Standard Puffer ist ' + ToggleBox_Standard_Puffer.Caption;
   if ToggleBox_Standard_Puffer.Checked then t:=t+' : ' + SpinEdit_Standard_Puffer.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Standard Zeilen ist ' + ToggleBox_Standard_Zeilen.Caption;
   if ToggleBox_Standard_Zeilen.Checked then t:=t+' : ' + SpinEdit_Standard_Zeilen.Value.toString;
   Memo_Auswerten.Append(t);
   Memo_Auswerten.Append('');
   t:='Analyse Frei ist ' + ToggleBox_Analyse_Frei.Caption;
   Memo_Auswerten.Append(t);
   t:='Analyse Verfahren ist ' + ToggleBox_Analyse_Verfahren.Caption;
   if ToggleBox_Analyse_Verfahren.Checked then t:=t+' : ' + SpinEdit_Analyse_Verfahren.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Analyse Puffer ist ' + ToggleBox_Analyse_Puffer.Caption;
   if ToggleBox_Analyse_Puffer.Checked then t:=t+' : ' + SpinEdit_Analyse_Puffer.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Analyse Zeilen ist ' + ToggleBox_Analyse_Zeilen.Caption;
   if ToggleBox_Analyse_Zeilen.Checked then t:=t+' : ' + SpinEdit_Analyse_Zeilen.Value.toString;
   Memo_Auswerten.Append(t);
   Memo_Auswerten.Append('');
   t:='Parameter Verfahren ist ' + ToggleBox_Parameter_Verfahren.Caption;
   if ToggleBox_Parameter_Verfahren.Checked then t:=t+' : ' + SpinEdit_Parameter_Verfahren.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Parameter Puffer ist ' + ToggleBox_Parameter_Puffer.Caption;
   if ToggleBox_Parameter_Puffer.Checked then t:=t+' : ' + SpinEdit_Parameter_Puffer.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Parameter Zeilen ist ' + ToggleBox_Parameter_Zeilen.Caption;
   if ToggleBox_Parameter_Zeilen.Checked then t:=t+' : ' + SpinEdit_Parameter_Zeilen.Value.toString;
   Memo_Auswerten.Append(t);
end;

procedure TForm1.Zeige;
begin
   Memo_Auswerten.Append('Aktuell');
   Memo_Auswerten.Append('Verfahren = ' + std_verf.toString);
   Memo_Auswerten.Append('Puffer    = ' + std_buffer.toString);
   Memo_Auswerten.Append('Zeilen    = ' + std_zeilen.toString);
   Memo_Auswerten.Append('');
end;

procedure TForm1.Ergebnis;
begin
   Memo_Auswerten.Append('Ergebnis');
   Memo_Auswerten.Append('Verfahren = ' + std_verf.toString);
   baumalgo:=std_verf=1;
   if baumalgo then blattmax:=std_buffer
               else buffermax:=std_buffer;
   if baumalgo
      then Memo_Auswerten.Append('Blaetter  = ' + blattmax.toString)
      else Memo_Auswerten.Append('Puffer    = ' + buffermax.toString);
   dynlaenge:=std_zeilen;
   Memo_Auswerten.Append('Dyn.Laenge= ' + dynlaenge.toString);
   Memo_Auswerten.Append('');
end;

procedure TForm1.Zeige_Parm;
var t:string;
begin
   Memo_Auswerten.Append('Parameter');
   t:='Verfahren/Parm = ' + JaNein(vparm_verf); if vparm_verf then t:=t + ' ' + parm_verf.toString;
   Memo_Auswerten.Append(t);
   t:='Puffer/Parm = ' + JaNein(vparm_buffer);  if vparm_buffer then t:=t + ' ' + parm_buffer.toString;
   Memo_Auswerten.Append(t);
   t:='Zeilen/Parm = ' + JaNein(vparm_zeilen);  if vparm_zeilen then t:=t + ' ' + parm_zeilen.toString;
   Memo_Auswerten.Append(t);
   Memo_Auswerten.Append('');
end;

procedure TForm1.Zeige_Analyse;
var t:string;
begin
   Memo_Auswerten.Append('Analyse');
   Memo_Auswerten.Append('Analyse frei      = ' + JaNein(analysefrei));
   t:='Verfahren/Analyse = ' + JaNein(vanly_verf); if vanly_verf then t:=t + ' ' + anly_verf.toString;
   Memo_Auswerten.Append(t);
   t:='Puffer/Analyse = ' + JaNein(vanly_buffer);  if vanly_buffer then t:=t + ' ' + anly_buffer.toString;
   Memo_Auswerten.Append(t);
   t:='Zeilen/Analyse = ' + JaNein(vanly_zeilen);  if vanly_zeilen then t:=t + ' ' + anly_zeilen.toString;
   Memo_Auswerten.Append(t);
   Memo_Auswerten.Append('');
end;

procedure TForm1.Auswerten_Analyse(ausgabe: boolean);
begin
   if ausgabe then Memo_Auswerten.Append('Auswerten, Setzen nach Analyse');
   if ausgabe then Memo_Auswerten.Append('Analyse erlaubt =   ' + JaNein(analysefrei));
   if analysefrei then begin
      IF vanly_verf      AND (anly_verf >= 0)      THEN std_verf:=anly_verf;
      IF vanly_buffer    AND (anly_buffer >= 0)    THEN std_buffer:=anly_buffer;
      IF vanly_zeilen    AND (anly_zeilen > 0)     THEN std_zeilen:=anly_zeilen;
   end;
   if ausgabe then Memo_Auswerten.Append('');
end;

procedure TForm1.Auswerten_Parm(ausgabe: boolean);
begin
   if ausgabe then Memo_Auswerten.Append('Auswerten, Setzen nach Parameter');
   IF vparm_verf      AND (parm_verf >= 0)      THEN std_verf:=parm_verf;
   IF vparm_buffer    AND (parm_buffer >= 0)    THEN std_buffer:=parm_buffer;
   IF vparm_zeilen    AND (parm_zeilen > 0)     THEN std_zeilen:=parm_zeilen;
   if ausgabe then Memo_Auswerten.Append('');
end;

procedure TForm1.Setze_B0_P0(ausgabe: boolean);
begin
   if ausgabe then Memo_Auswerten.Append('Verfahren/alt = ' + std_verf.toString);
   if ausgabe then Memo_Auswerten.Append('Puffer/alt    = ' + std_buffer.toString);
   if std_verf = 0
      then std_buffer:=0
      else if std_buffer = 0
              then std_verf:=0;
   if ausgabe then Memo_Auswerten.Append('Verfahren/neu = ' + std_verf.toString);
   if ausgabe then Memo_Auswerten.Append('Puffer/neu    = ' + std_buffer.toString);
   if ausgabe then Memo_Auswerten.Append('');
end;

procedure TForm1.Button_AuswertungClick(Sender: TObject);
begin
   Scannen_Werte;
   Memo_Auswerten.Clear;
   Zeige;

   Zeige_Analyse;
   Auswerten_Analyse(true);
   Zeige;

   Zeige_Parm;
   Auswerten_Parm(true);
   Zeige;

   Setze_B0_P0(true);

   Ergebnis;
end;

procedure TForm1.Button_ErgebnisClick(Sender: TObject);
begin
   Scannen_Werte;
   Auswerten_Analyse(false);
   Auswerten_Parm(false);
   Setze_B0_P0(false);
   Memo_Auswerten.Clear;
   Ergebnis;
end;

end.
